#include "BasicWindow.hpp"

BasicWindow::BasicWindow(QWidget *parent): QWidget(parent) {  /*!< The constructor. */
	
	this->setWindowTitle("Directive  .");     /*!< To set the window's title. */
		isCalled = false;
		// Instanciation des classes.
		// Déclaration des boutons et champs de saisie de texte.
		compteur		= 0;
		
		m_nameLabel  		= new QLabel("Entrée 1: ");    /*!< QLabel for Nom de la constante . */
		m_valueLabel 		= new QLabel("Entrée 2: ");  /*!< QLabel for Valeur de la constante. */

		m_ligneNom  		= new QLineEdit(this) ;    /*!< Name of the QLineEdit. */
		m_ligneValeur 		= new QLineEdit(this) ;   /*!< Value of the QLineEdit. */

		m_addButton 		= new QPushButton("Ajouter", this);   /*!< QPushButton for Ajout. */
		m_helpButton           = new QPushButton("De l'aide ?");   /*!< QPushButton for aide. */
		m_delButton 		= new QPushButton("Supprimer", this);  /*!< QPushButton for Supprimer. */
			m_delButton ->setDisabled(true);	  /*!< setDisabled is true. */
		m_saveButton		= new QPushButton("Enregistrer", this);   /*!< QPushButton for Enregistrer. */
			m_saveButton->setDisabled(true);
		m_quitButton 			= new QPushButton("Quitter", this);   /*!< QPushButton for Quitter. */

		QStringList horizontalHeaders;
			horizontalHeaders << "Constante(s)"  << "Valeur(s)" << " ";  /*!< added Nom Netward Entrees and sorties in table */
		m_tableView  			= new QTableWidget(0, 2);  /*!< QTableWidget's in whitch the objects are listed for thue view. */
			m_tableView->setEditTriggers(QAbstractItemView::NoEditTriggers); /*!< this ligne give no edit mode*/
			m_tableView->setShowGrid(false);  /*!< this ligne cover the grille in table */
			m_tableView->setSelectionBehavior(QAbstractItemView::SelectRows);  /*!< this ligne give a section of the ligne */
		   	m_tableView->setHorizontalHeaderLabels(horizontalHeaders); /*!< displays the QTableWidget */
	//--------- Les gestionnaires de positionnement.
		m_layoutH1         	= new QHBoxLayout;
			m_layoutH1->addWidget(m_saveButton);
	 		m_layoutH1->addWidget(m_quitButton );//m_addButton );
		m_layoutGrid 		= new QGridLayout;  /*!< set QGridLayout m-layoutG  */
		m_layoutGrid->addWidget(m_nameLabel  , 0, 2);
		m_layoutGrid->addWidget(m_ligneNom , 0, 3, 1, 2);
		m_layoutGrid->addWidget(m_valueLabel , 1, 2);
		m_layoutGrid->addWidget(m_ligneValeur , 1, 3, 1, 2);
		m_layoutGrid->addWidget(m_helpButton, 3, 1); /*!<  m_ helpButton in the QGridLayout */
		m_layoutGrid->addWidget(m_tableView , 2, 2, 4, 3); /*!< added m_m_tableView  in the QGridLayout */
		m_layoutGrid->addWidget(m_addButton , 3, 5);  /*!< added m_addButton  in the QGridLayout */
		m_layoutGrid->addWidget(m_delButton , 4, 5); /*!< added m_delButton  in the QGridLayout */
		m_layoutGrid->addLayout(m_layoutH1 , 6, 2, 1, 3);  /*!< added m_save Button in the QGridLayout */

	//index = m_tableView ->currentIndex();

	m_modeleListeNoms 			= new QStringListModel(m_listeNoms);

	this->setLayout(m_layoutGrid); //Activation du gestionnaire principal.

	// Gestion des connexions entre les widgets.
	connect(m_quitButton, SIGNAL(clicked()), this, SLOT(close()));  /*!< slot for the close this windows*/
	connect(m_addButton, SIGNAL(clicked()), this, SLOT(addRowInTable()));  /*!< This slot add the object in the view */
	connect(m_delButton, SIGNAL(clicked()), this, SLOT(deleteRow())); /*!< To delete the object selected in the view*/
	connect(m_saveButton, SIGNAL(clicked()), this, SLOT(saveData())); /*!< This slot save data in structure */

	this->setFixedWidth(baseSize().width() + 410);
}
/****************************************** addRowInTable() method **********************************************/
void BasicWindow::addRowInTable() {

	addRow();				// Permet de créer une nouvelle dans le tableau d'affichage.

	testContenu(compteur);	// Permet de vérifier si une ligne est présente dans le tableau d'affichage.
							// Au cas échéant, on ne désactive pas les boutons "Enregistrer" et "Supprimer". 
	
    static int i = 1;
    static int j = 1;
	QString Nom  = m_ligneNom->text();
	QString Val  = m_ligneValeur->text();


	for(int i1 = 0; i1 < Nom.size(); i1++)
		if(!((Nom .at(i1) >= QChar('a')&& Nom .at(i1) <= QChar('z')) || (Nom .at(i1) >= QChar('A')&& Nom .at(i1) <= QChar('Z'))
			|| (Nom .at(i1) >= QChar('0')&& Nom .at(i1) <= QChar('9')) || (Nom .at(i1) == QChar('_')))) //|| (line1.isEmpty())
			{
				QMessageBox::critical(this, "Erreur", "Veuillez entrer une valeur exacte du nom de la constante.");
				return; // Arrêt de la méthode
			}
	for(int i2 = 0; i2 < Val.size(); i2++)
		if(!((Val .at(i2) >= QChar('a') && Val .at(i2) <= QChar('z')) || (Val .at(i2) >= QChar('A')&& Val .at(i2) <= QChar('Z')) 
			||(Val .at(i2) >= QChar('0') && Val .at(i2) <= QChar('9')) || (Val .at(i2) == QChar('_')) || (Val .at(i2) == QChar('-')) 
			|| (Val .at(i2) == QChar('E')) || (Val .at(i2) == QChar('e')) || (Val .at(i2) == QChar('+')) || (Val .at(i2) == QChar('.')))) {

				QMessageBox::critical(this, "Erreur", "Veuillez entrer une valeur correcte pour la constante.");
				return; // Arrêt de la méthode
			}
	if (m_ligneNom->text().isEmpty())
		{
			QMessageBox::critical(this, "Erreur", "Le champ du nom de la constante est vide: entrer un nom SVP!");
			return; // Arrêt de la méthode
		}

	if ((i!=0)&&(j!=0)) {
		if (isCalled) {--i ; isCalled = false; }

	addNameInTable(i, j, m_ligneNom->text());
	m_listeNoms.append(m_ligneNom->text() + " " + m_ligneValeur->text());
	addValueInTable(i, j, m_ligneValeur->text());
	i++;
	}

	initialiserChamps();
}
/************************************ addRow() method ****************************************************/
void BasicWindow::addRow() {

	int row = m_tableView->rowCount();
	m_tableView->insertRow(row);
	compteur ++;
}

/************************************ delete Row() method ****************************************************/
void BasicWindow::deleteRow() {

	m_tableView->removeRow(m_tableView->currentRow());
	isCalled = true;
	-- compteur;
	testContenu(compteur);
}

/****************************************************************************************/
void BasicWindow::addNameInTable(int ligne, int colonne, QString nom ) {

	QTableWidgetItem *chaine = new QTableWidgetItem;
		chaine->setText(nom );

	m_tableView->setItem(ligne-1, colonne-1, new QTableWidgetItem(nom ));
}

/****************************************************************************************/
void BasicWindow::addValueInTable(int ligne, int colonne, QString valeur ) {

	QTableWidgetItem *chaine = new QTableWidgetItem;
		chaine->setText(valeur );

	m_tableView->setItem(ligne - 1, colonne, chaine);
}

/*****************************************************************************************************************************************************/
void BasicWindow::saveData() {

	QTableWidgetItem *cell1 = new QTableWidgetItem;
	QTableWidgetItem *cell2 = new QTableWidgetItem;	
	
	for (int i = 0; i < m_tableView->rowCount() ; i++) {

			cell1 = m_tableView->item(i, 0);
			cell2 = m_tableView->item(i, 1);
				
			m_savedData.push_back(cell1->text() + " " + cell2->text());

	}
	//for (QStringList::iterator it =  Data.begin(); it !=  Data.end(); it++)
	//cout << "Voici les valeurs ajoutées: " << it->toStdString() <<endl;
	m_quitButton->setEnabled(true);
}
/*****************************************************************************************************************************************************/
void BasicWindow::initialiserChamps() {

	m_ligneNom->setText("");
	m_ligneValeur->setText("");
}



/************************************ testContenu() ***************************************************/
bool BasicWindow::testContenu(int anInt) {

	if (anInt != 0) {
		m_delButton->setEnabled(true);
		m_saveButton->setEnabled(true);
	}
	else
	{
		m_delButton->setDisabled(true);
		m_saveButton->setDisabled(true);
	}
}
/****************************************************************************************************************************/
QStringList BasicWindow::getData () {

	return  m_savedData;
}
/****************************************************************************************/
void BasicWindow::closeEvent(QCloseEvent *event) {

		//QTextCodec::setCodecForCStrings(QTextCodec::codecForName("UTF-8"));
	QMessageBox msgBox;
		msgBox.setText("Aucune information n'a été saisie!");
 		msgBox.setInformativeText("Etes-vous sûr de vouloir quitter?");
 		msgBox.setStandardButtons(QMessageBox::Yes | QMessageBox::Cancel);
 		msgBox.setDefaultButton(QMessageBox::Yes);
 	int ret = msgBox.exec();

	if (ret == QMessageBox::Yes)
                event->accept();
	else event->ignore();
	
	//QMessageBox::warning(this, tr("Application"), tr("Le document a été modifié.\n Voulez-vous sauvegarder les modifications apportées?"),
          //              QMessageBox::Yes | QMessageBox::Default,
            //            QMessageBox::No,
              //          QMessageBox::Cancel | QMessageBox::Escape);
 
  //    if (maybeSave()) {
            //writeSettings();
    //        event->accept();
      //} 
	//else 
          //  event->ignore();
      
}
/***************************************************************************************************************/
/*bool BasicWindow::maybeSave()
{
      if (isWindowModified()) {
            int ret = QMessageBox::warning(this, tr("Application"),
                        tr("The document has been modified.\n"
                        "Do you want to save your changes?"),
                        QMessageBox::Yes | QMessageBox::Default,
                        QMessageBox::No,
                        QMessageBox::Cancel | QMessageBox::Escape);
            if (ret == QMessageBox::Yes)
	     return true;//return save();
            else if (ret == QMessageBox::Cancel)
            return false;
      }
      return true;
}*/	

/************************************************************************************/

/*bool BasicWindow::enregData (bool tar) {

	save Data();//return  Data;
	return tar;
}*/
/********************************************************************************/


